// TimerEventView.cpp : implementation of the CTimerEventView class
//

#include "stdafx.h"
#include "TimerEvent.h"

#include "TimerEventDoc.h"
#include "TimerEventView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimerEventView
#define  IDT_TIMER  WM_USER + 200  
int iHour,iMinute,iSecond;            // Global Variables
CString Label;                   
BOOL Status=FALSE;
IMPLEMENT_DYNCREATE(CTimerEventView, CFormView)

BEGIN_MESSAGE_MAP(CTimerEventView, CFormView)
	//{{AFX_MSG_MAP(CTimerEventView)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_CBN_SELCHANGE(IDC_OPERATION, OnSelchangeOperation)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimerEventView construction/destruction

CTimerEventView::CTimerEventView()
	: CFormView(CTimerEventView::IDD)
{
	//{{AFX_DATA_INIT(CTimerEventView)
	m_sCurrtime = _T("");
	m_sUserTime = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CTimerEventView::~CTimerEventView()
{
}

void CTimerEventView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimerEventView)
	DDX_Control(pDX, IDC_USERTIME, m_cUTime);
	DDX_Control(pDX, IDC_EXIT, m_cExit);
	DDX_Control(pDX, IDC_OPERATION, m_cOperation);
	DDX_Control(pDX, IDC_CANCEL, m_cCancel);
	DDX_Text(pDX, IDC_CURRTIME, m_sCurrtime);
	DDX_Text(pDX, IDC_USERTIME, m_sUserTime);
	DDV_MaxChars(pDX, m_sUserTime, 8);
	//}}AFX_DATA_MAP
}

BOOL CTimerEventView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CTimerEventView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	/* My Code Starts Here*/
	m_cUTime.SetFocus();
	m_cCancel.EnableWindow(FALSE);
	Timeval=StartTimer(1000);
	SetWindowPos(&CWnd::wndTop, 670, 350, 0, 0, SWP_SHOWWINDOW|SWP_NOSIZE);

}

/////////////////////////////////////////////////////////////////////////////
// CTimerEventView printing

BOOL CTimerEventView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTimerEventView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTimerEventView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CTimerEventView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	// TODO: add customized printing code here
}

/////////////////////////////////////////////////////////////////////////////
// CTimerEventView diagnostics

#ifdef _DEBUG
void CTimerEventView::AssertValid() const
{
	CFormView::AssertValid();
}

void CTimerEventView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CTimerEventDoc* CTimerEventView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTimerEventDoc)));
	return (CTimerEventDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTimerEventView message handlers

void CTimerEventView::OnCancel() 
{
	// TODO: Add your control notification handler code here
//	m_cCancel.EnableWindow(FALSE);
	m_cUTime.EnableWindow(TRUE);            //Enabling the Shutdown Time Edit Control 
	m_cExit.EnableWindow(TRUE);				  //Enable Exit Button 
	m_cOperation.EnableWindow(TRUE);           //Enable List Control
	Status=TRUE;
	
}

void CTimerEventView::OnExit() 
{
	// TODO: Add your control notification handler code here
	if(StopTimer(Timeval)==FALSE)
		::MessageBox(NULL,"Error While Killing the Timer","ShutEvt",1);

	::PostQuitMessage(1);

	
}

UINT  CTimerEventView::StartTimer (UINT TimerDuration)

    {
        UINT    TimerVal;
        TimerVal = SetTimer (IDT_TIMER, TimerDuration, NULL);  // Starting the Timer
        if (TimerVal == 0)
        {
              AfxMessageBox("Unable to obtain timer");
        }
      return TimerVal;
    }// end StartTimer
BOOL CTimerEventView::StopTimer (UINT TimerVal)
   {
          if (!KillTimer (TimerVal))
          {
			   return FALSE;
          }
          //    Place clean-up code following this point.
         return TRUE;
   } // end StopTimer

void CTimerEventView::OnUnlock() 
{
	WinExec("rundll32 user32.dll,LockWorkStation",1);  // Lock the System
}

void CTimerEventView::OnCheck() 
{
	int iLHour,iLMinute;
	CString tmpTime,subTime;

	UpdateData();
	
	tmpTime=m_sUserTime;
	iLHour=tmpTime.Find(":",0);
	subTime=tmpTime.Left(iLHour);
	iHour=atoi(subTime);
	
	if(iLHour==2 && iHour>=0 && iHour<=24)
	{	
		iLMinute=tmpTime.Find(":",iLHour);
		subTime=tmpTime.Mid(iLHour+1);
		subTime=subTime.Left(iLMinute);
		iMinute=atoi(subTime);
		if(iLMinute==2 && iMinute>=0 && iMinute<=60)
		{
			iSecond=atoi(tmpTime.Right(2));
			
			if(iSecond>=0 && iSecond<=60)
			{
				m_cUTime.EnableWindow(FALSE);           
				m_cCancel.EnableWindow(FALSE);
				m_cCancel.EnableWindow(TRUE);
				m_cExit.EnableWindow(FALSE);
				m_cOperation.EnableWindow(FALSE);
			}
			else
			::MessageBox(NULL,"Enter the Date in  HH:MM:SS \n\n OR \n\n Seconds Should be between 0 and 60","ShutEvt",1);
		
		}
		else
			::MessageBox(NULL,"Enter the Date in HH:MM:SS\n\n OR \n\n Minutes Should be between 0 and 60","ShutEvt",1);
					
	}
	else
		::MessageBox(NULL,"Enter the Date in HH:MM:SS \n\n OR \n\n Hour should be between 0 and 24","ShutEvt",1);
	
}


BOOL CTimerEventView::MyTask(CString strType)
{
    HANDLE hToken; 
    TOKEN_PRIVILEGES tkp; 
   // Stop the timer before shutdown 
	StopTimer(Timeval);
   // Get a token for this process. 

   if (!OpenProcessToken(GetCurrentProcess(), 
        TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) 
      return( FALSE ); 
 
   // Get the LUID for the shutdown privilege. 
 
   LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, 
        &tkp.Privileges[0].Luid); 
 
   tkp.PrivilegeCount = 1;  // one privilege to set    
   tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
 
   // Get the shutdown privilege for this process. 
 
   AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, 
        (PTOKEN_PRIVILEGES)NULL, 0); 
 
   if (GetLastError() != ERROR_SUCCESS) 
      return FALSE; 
 
   // Shut down the system and force all applications to close. 
 
  // if (!ExitWindowsEx(EWX_POWEROFF | EWX_POWEROFF | EWX_FORCE, 0)) 
   
   if(strType=="LogOff")
   {
		if(!ExitWindowsEx(EWX_LOGOFF | EWX_FORCE, 0)) 
	      return FALSE; 
   }
   else if(strType=="ShutDown")
   {
		if(!ExitWindowsEx(EWX_SHUTDOWN|EWX_POWEROFF| EWX_FORCE, 0)) 
	      return FALSE; 
   }
   else if(strType=="Restart")
   {
		if(!ExitWindowsEx(EWX_REBOOT| EWX_FORCE, 0)) 
	      return FALSE; 
   }

   return TRUE;
}

void CTimerEventView::OnSelchangeOperation() 
{
	// TODO: Add your control notification handler code here
		Status=FALSE;
	int Selection=m_cOperation.GetCurSel();
		OnCheck();
	m_cOperation.GetLBText(Selection,Label);

}

void CTimerEventView::OnTimer(UINT nIDEvent) 
{
	CTime ct=CTime::GetCurrentTime();
	char *str=new char[10];

	UpdateData();
	m_sCurrtime.Format("%d : %d : %d ",ct.GetHour(),ct.GetMinute(),ct.GetSecond());
	UpdateData(FALSE);
	
	if(iHour==ct.GetHour() && iMinute==ct.GetMinute() && iSecond==ct.GetSecond() && Label=="Lock" && Status==FALSE)
	{
		OnUnlock();
		m_cUTime.EnableWindow(TRUE);            //Enabling the Shutdown Time Edit Control 
		m_cExit.EnableWindow(TRUE);				  //Enable Exit Button 
		m_cOperation.EnableWindow(TRUE);           //Enable List Control
		//StopTimer(Timeval);
		Status=TRUE;
	}
	if(iHour==ct.GetHour() && iMinute==ct.GetMinute() && iSecond==ct.GetSecond() && Label=="LogOff" && Status==FALSE)
	{
		MyTask("LogOff");
	}
	
	if(iHour==ct.GetHour() && iMinute==ct.GetMinute() && iSecond==ct.GetSecond() && Label=="ShutDown" && Status==FALSE)
	{
		MyTask("ShutDown");
	}
	if(iHour==ct.GetHour() && iMinute==ct.GetMinute() && iSecond==ct.GetSecond() && Label=="Restart" && Status==FALSE)
	{
		MyTask("Restart");
	}

	delete [] str;
	CFormView::OnTimer(nIDEvent);
}


